--      
--   --
SET XACT_ABORT ON
BEGIN TRAN

USE {Variable_WorkDb}
GO

DECLARE
	@LINK_TASK	INT,
	
	@BEGIN_YEAR	DATETIME,
	@END_YEAR	DATETIME

SET	@LINK_TASK = dbo.OBJ_ID ('SMETA')
SET	@BEGIN_YEAR	= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)	--   
SET	@END_YEAR = DATEADD (DAY, -1, DATEADD(YEAR, 1, @BEGIN_YEAR))

INSERT INTO dbo.DEPARTMENTS_DATE
	(
	LINK_TASK,
	DEP_LINK,
	BEGINDATE,
	WORKDATE,
	ENDDATE,
	AUTO_PERIOD,
	AUTO_WORK,
	PERIOD_TYPE
	)

SELECT
	@LINK_TASK,
	DEP.LINK,
	@BEGIN_YEAR,
	@END_YEAR,
	@END_YEAR,
	0,
	0,
	2
FROM dbo.DEPARTMENTS DEP 
INNER JOIN {Variable_TempDb}.dbo.[__DEPARTMENTS_] T1 ON (T1.LINK = DEP.LINK)
WHERE NOT EXISTS
			(
			SELECT 1
			FROM dbo.DEPARTMENTS_DATE TTT
			WHERE TTT.DEP_LINK = T1.LINK
				AND TTT.LINK_TASK = @LINK_TASK
			)

COMMIT TRAN

GO

