
set xact_abort on
BEGIN TRAN
--  
USE [{Variable_TempDb}]
GO


                 
--,        ( ,     )
IF (EXISTS (SELECT * 
                 FROM INFORMATION_SCHEMA.TABLES 
                 WHERE TABLE_SCHEMA = 'dbo' 
                 AND  TABLE_NAME = 'CatalogObject|'))
BEGIN

    SELECT LIC_SCHET 
    INTO #T0
    FROM [{Variable_WorkDb}].dbo.PERSON_ECARDS
    

    
    CREATE TABLE #LINKS (LINK INT)

    INSERT INTO [{Variable_WorkDb}].dbo.PERSON_ECARDS
    (PERS_LINK, BANK_LINK, CARD_LINK, LIC_SCHET, OSN, ACTUAL, FILIAL, DOGOVOR, DATE_DOG,
    INDIVIDUAL)
    OUTPUT INSERTED.LINK
    INTO #LINKS
    SELECT 
        PERS_LINK   = kep.LINK, 
        BANK_LINK   = NULL, 
        CARD_LINK   = NULL, 
        LIC_SCHET   = B., 
        OSN         = 0, 
        ACTUAL      = 1, 
        FILIAL      = '', 
        DOGOVOR     = '', 
        DATE_DOG    = NULL,
        INDIVIDUAL  = 1
    FROM [{Variable_TempDb}].dbo.[CatalogObject|] b
    INNER JOIN [{Variable_TempDb}].dbo.__EMPL_ e ON E.Ref = B.
    INNER JOIN [{Variable_WorkDb}].dbo.KU_EMPL_PLACING kep ON kep.LINK = e.LINK
    WHERE B. NOT IN (SELECT LIC_SCHET FROM #T0)

    --    
    DECLARE @iROWCOUNT INT
    SET @iROWCOUNT = @@ROWCOUNT

    IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_ECARDS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
    DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_ECARDS]

    SELECT
               = isnull(b.,''), 
           = isnull(kep.FIO,''),
      = '      '
    INTO [{Variable_TempDb}].dbo.[__JOURNAL_ECARDS]
    FROM [{Variable_TempDb}].dbo.[CatalogObject|] b
    INNER JOIN [{Variable_TempDb}].dbo.__EMPL_ e ON E.Ref = B.
    INNER JOIN [{Variable_WorkDb}].dbo.KU_EMPL_PLACING kep ON kep.LINK = e.LINK
    WHERE B. IN (SELECT LIC_SCHET FROM #T0)
    ORDER BY 

    DECLARE @iROWS_NOT_COPIED BIGINT
    SET @iROWS_NOT_COPIED = @@ROWCOUNT
    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES (' " "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_ECARDS',ISNULL(@iROWS_NOT_COPIED,0))
    --

    DROP TABLE #T0
    DROP TABLE #LINKS
END

COMMIT TRAN
