USE {Variable_TempDb}
/*  ,  NUMERIC(19,4)   NVARCHAR(MAX) ( 0,    ) */
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[getNumeric]') AND xtype in (N'FN', N'IF', N'TF'))
DROP FUNCTION dbo.[getNumeric]

GO

CREATE   FUNCTION dbo.getNumeric(@sVALUE NVARCHAR(MAX))

RETURNS NUMERIC(24,4)
AS
BEGIN
	DECLARE @nRESULT NUMERIC(24,4)
	IF ISNUMERIC(@sVALUE) = 0
	BEGIN
	 SET @nRESULT = 0
	END
	ELSE
	 SET @nRESULT = CONVERT(NUMERIC(24,4),@sVALUE) 
	RETURN @nRESULT
END

GO

--   --
--      --
DECLARE
	@SQL_EXEC	VARCHAR (4000),

	@DB_KR	INT,
	@DB_KR_STR	VARCHAR (2),
	@FIELD_NUMBER	INT,
	@FIELD_NAME	VARCHAR (50),

	@TAB_ID	INT,
	@SQL_CHECK_FIELD	VARCHAR (2000),
	@SQL_SET_DD	VARCHAR (2000)

IF OBJECT_ID ('TEMPDB..#CHECK_TABLE') IS NOT NULL
	EXEC ('DROP TABLE #CHECK_TABLE')

CREATE TABLE #CHECK_TABLE (CHECK_RES TINYINT)

--      --
SET @SQL_CHECK_FIELD = 
'
IF EXISTS (SELECT TOP 1 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] A
			INNER JOIN [{Variable_TempDb}].dbo.[__NOMENCLATURE_] B ON B.REF = A.{FIELD_NAME})
	INSERT INTO #CHECK_TABLE (CHECK_RES) VALUES (1)
'

--     [NOMEN] --
-- !!!  _N_DB_KR     !!!
SET @SQL_SET_DD = 
'
UPDATE A 
SET [NOMEN_{DB_KR}] = A.[{FIELD_NAME}]
--SELECT [NOMEN_{DB_KR}], A.[{FIELD_NAME}]
FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] A
INNER JOIN [{Variable_TempDb}].dbo.[__NOMENCLATURE_] B ON B.REF = A.{FIELD_NAME}
'

--      --
IF EXISTS (SELECT TOP 1 1 FROM [{Variable_TempDb}].[SYS].[TABLES]
			WHERE [NAME] = '__NOMENCLATURE_')
BEGIN
-- [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|]
	SELECT TOP 1 
		@TAB_ID = [OBJECT_ID]
	FROM [{Variable_TempDb}].[SYS].[TABLES]
	WHERE [NAME] = 'AccountingRegisterRecordSet|'

	SET @DB_KR = 0
	WHILE @DB_KR < 2
	BEGIN
		IF @DB_KR = 0
			SET @DB_KR_STR = 'DR'
		ELSE
			SET @DB_KR_STR = 'CR'

		--    --
		SET @FIELD_NUMBER = 1

		DELETE FROM #CHECK_TABLE

		WHILE @FIELD_NUMBER < 6
		BEGIN
			SET @FIELD_NAME = '_' + CONVERT (VARCHAR (1), @FIELD_NUMBER) + '_' + @DB_KR_STR

			--    _N_DB_KR,   --
			IF EXISTS (SELECT TOP 1 1 FROM [{Variable_TempDb}].[SYS].[COLUMNS]
						WHERE [OBJECT_ID] = @TAB_ID AND [NAME] = @FIELD_NAME)
			BEGIN
				SET @SQL_EXEC = REPLACE (@SQL_CHECK_FIELD, '{FIELD_NAME}', @FIELD_NAME)
--			PRINT @SQL_EXEC
				EXEC (@SQL_EXEC)

				--  .  NOMEN_DB_KR --
				IF EXISTS (SELECT 1 FROM #CHECK_TABLE)	
				BEGIN
					SET @SQL_EXEC = REPLACE (@SQL_SET_DD, '{FIELD_NAME}', @FIELD_NAME)
					SET @SQL_EXEC = REPLACE (@SQL_EXEC, '{DB_KR}', @DB_KR_STR)
					EXEC (@SQL_EXEC)

					SET @FIELD_NUMBER = 5
				END
			END

			SET @FIELD_NUMBER = @FIELD_NUMBER + 1
		END

		SET @DB_KR = @DB_KR + 1
	END	-- 	WHILE @DB_KR < 2
END

IF OBJECT_ID ('TEMPDB..#CHECK_TABLE') IS NOT NULL
	EXEC ('DROP TABLE #CHECK_TABLE')

GO
UPDATE [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|]
SET [] = NULL
WHERE [] = '00000000-0000-0000-0000-000000000000'
GO

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--  .  __PROV_HDR_1C
IF exists(select * from sysobjects where id = object_id('[dbo].[__PROV_HDR_1C]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	EXEC ('DROP TABLE [dbo].[__PROV_HDR_1C]')

EXEC ('
	CREATE TABLE [dbo].[__PROV_HDR_1C]
		(
		LINK	INT,
		RecordRef	VARCHAR (1000),
		RECORDER	UNIQUEIDENTIFIER,

		[DEP_LINK] int NOT NULL,
		[DATE] datetime NULL ,
		[SUMMA] numeric (28, 2) NULL ,
		[QTY] numeric (28, 4) NULL,

		[NUMBER]	VARCHAR (30),
		COMMENT	VARCHAR (254)
		)
		'
		)
	
--  .  __PROV_ANALIT_1C
IF exists(select * from sysobjects where id = object_id('[dbo].[__PROV_ANALIT_1C]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	EXEC ('DROP TABLE [dbo].[__PROV_ANALIT_1C]')

EXEC ('
	CREATE TABLE [dbo].[__PROV_ANALIT_1C]
		(
		LINK_UP	INT,
		RECORDER	UNIQUEIDENTIFIER,
		DB_KR	TINYINT,

		ACCOUNT	INT NULL,
		ACC_CODE	VARCHAR (20) NULL,
		
		[KBK] int NULL ,
		[EKR] int NULL ,
		[DEP] int NULL ,
		[SUB] int NULL ,
		[EMP] int NULL ,
		[NOMEN] int NULL ,
		[INV] int NULL ,
		[KAU] int NULL ,
		[DEP_ACC] int NULL ,
		[TMC] int NULL ,
		[INDATE] datetime NULL ,
		[SGU] int NULL ,
		[AP1] int NULL ,
		[AP2] int NULL ,
		[AP3] int NULL ,
		[AP4] int NULL ,
		[AP5] int NULL ,
		[AP6] int NULL
		)
		'
		)
GO

set xact_abort ON
BEGIN TRAN

USE {Variable_TempDb}

IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
CREATE TABLE #EXEC (text varchar(8000), id int identity(1,1))
GO

IF OBJECT_ID('TEMPDB..#tSQL_FROM','U') IS NOT NULL
	DROP TABLE #tSQL_FROM
GO
	
CREATE TABLE #tSQL_FROM (text varchar(8000), ORD1 int identity(1,1))
GO

--    Dr = '' --
UPDATE AR
SET Dr = NULL
from [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] AR
WHERE CONVERT (VARCHAR (100), Dr) = ''
GO

--    Cr = '' --
UPDATE AR
SET Cr = NULL
from [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] AR
WHERE CONVERT (VARCHAR (100), Cr) = ''
GO

--   --
INSERT INTO #EXEC ([text]) SELECT
'
IF OBJECT_ID (''TEMPDB..#INV_NUM_PROV'') IS NOT NULL 
	EXEC (''DROP TABLE #INV_NUM_PROV'')

CREATE TABLE #INV_NUM_PROV
	(
	LINK_DOC	INT,
	LINK_EVENT	INT,
	INV	NVARCHAR (100),
	INV_NUM	NVARCHAR (100),
	ROW_NUM	INT,
	DB_KR	TINYINT
	)

INSERT INTO #INV_NUM_PROV
	(
	LINK_DOC,
	LINK_EVENT,
	INV,
	INV_NUM,
	ROW_NUM,
	DB_KR
	)
SELECT
	T1.LINK,
	T2.LINK,
	T1.INV,
	T2.[],
	T1.ROW_NUM,
	T1.DB_KR
FROM
	(
	SELECT
		T1.LINK,
		ROW_NUM	=	ROW_NUMBER() OVER (PARTITION BY T1.recorder, T1.INV_DR ORDER BY T1.LINK),
		INV	=	T1.INV_DR,
		DB_KR	=	0,
		T1.RECORDER
	FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] T1
	WHERE T1.INV_DR IS NOT NULL

	UNION

	SELECT
		T1.LINK,
		ROW_NUM	=	ROW_NUMBER() OVER (PARTITION BY T1.recorder, T1.INV_CR ORDER BY T1.LINK),
		INV	=	T1.INV_CR,
		DB_CR	=	1,
		T1.RECORDER
	FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] T1
	WHERE T1.INV_CR IS NOT NULL
	) AS T1

INNER JOIN 
	(
	SELECT
		LINK1 = T1.LINK,
		ROW_NUM	=	ROW_NUMBER() OVER (PARTITION BY T1.recorder, T1. ORDER BY T1.LINK),
		*
	FROM [{Variable_TempDb}].dbo.[InformationRegisterRecordSet|] T1
	WHERE T1.[] <> ''00000000-0000-0000-0000-000000000000''
	) T2 ON 
		T2.RECORDER = T1.RECORDER
		AND T2.ROW_NUM	=	T1.ROW_NUM
		AND T2.	=	T1.INV
INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] INV ON
	INV.[Ref] = T1.INV
	AND INV.[] = ''true''

'
--  .  __PROV_HDR_1C
INSERT INTO #EXEC ([text]) SELECT
'    
INSERT INTO [{Variable_TempDb}].[dbo].[__PROV_HDR_1C] 
    (
	LINK,
	RecordRef, RECORDER, [DEP_LINK], [DATE],
	[SUMMA], [QTY],
	[NUMBER], COMMENT
	)
'

INSERT INTO #EXEC ([text]) SELECT
'    
SELECT
	LINK	=	ar.LINK,
    Ref        = ar.RecordRef,
	AR.RECORDER,
	DEP_LINK   = do.LINK,
    DATE       = cast( floor( cast( ar.Period AS float ) ) AS datetime ),

    SUMMA    = ISNULL(AR.,0),--CASE WHEN AR. <> ISNULL(ar.Dr,ar.Cr) AND AR. = 0 THEN ISNULL(ar.Dr,ar.Cr) ELSE AR. END, 
	QTY = [{Variable_TempDb}].dbo.getNumeric(ISNULL (ar.Dr, ar.Cr)),

	[NUMBER] =	LEFT(ar.,30),
	COMMENT	= AR.
'

INSERT INTO #EXEC ([text]) SELECT
'     
FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = AR.
'

INSERT INTO #EXEC ([text]) SELECT
' 
WHERE ar.[Active] = 1
'

--   FROM    --
INSERT INTO #tSQL_FROM ([text]) SELECT

'     
FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = AR.
INNER JOIN [{Variable_WorkDb}].dbo.V_DEP CB on CB.LINK = do.LINK

INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] acc ON acc.Ref = AR.Account{DB_KR}
LEFT JOIN [{Variable_TempDb}].dbo.[__] fo on fo.name= ar.
LEFT MERGE JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_1C sa ON sa.CODE = fo.code + ''.'' + acc.Code
	AND sa.LINK_DEP = CB.LINK_CB	-- {LINK_DEP} --{LINK_DEP}

LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d ON d.Ref = ar.DEP_{DB_KR}
LEFT JOIN [{Variable_TempDb}].dbo.__NOMENCLATURE_ n ON n.Ref = ISNULL(ar.ND_{DB_KR},ar.NOMEN_{DB_KR}) --   ,  
LEFT JOIN [{Variable_TempDb}].dbo.__NOMENCLATURE_ bso ON bso.Ref = ar.BSO_{DB_KR}
LEFT JOIN [{Variable_TempDb}].dbo.[__NOMENCLATURE_] DD ON DD.Ref = ar.NOMEN_{DB_KR}
LEFT JOIN [{Variable_TempDb}].dbo.[__INVENTORY__] INV1 ON INV1.[INSERTED_UIDS] = ar.INV_{DB_KR}

LEFT JOIN #INV_NUM_PROV i_gr on i_gr.LINK_DOC = ar.link
	and i_gr.DB_KR = 0
LEFT JOIN [{Variable_TempDb}].dbo.[__INVENTORY__] INV2 ON INV2.[REF] = i_gr.INV_NUM

LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] cmo ON cmo.Ref = ar.EMP_{DB_KR}
LEFT JOIN [{Variable_TempDb}].dbo.__EMPL_ es ON es.Ref = convert(uniqueidentifier,cmo.)
LEFT JOIN [{Variable_TempDb}].dbo.[__SUBDIV_] SP ON SP.Ref = convert(uniqueidentifier,cmo.[])

LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co ON
	co.Ref =  coalesce(case when ar.{DB_KR} <>'''' then ar.{DB_KR} else null end, ar.SGU_{DB_KR}) 
LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU k ON RIGHT(co.Code,3) = k.CODE

LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] ekr ON ekr.Ref = ar.EKR_{DB_KR}
LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU k2 ON RIGHT(ekr.Code,3) = k2.CODE

LEFT JOIN 
	(SELECT kk.Ref, KBK.LINK, KBK.[TYPE], CNT = COUNT(*) OVER (PARTITION BY kk.Ref)
		FROM [{Variable_TempDb}].dbo.__KL_KBK_ kk 
		INNER JOIN [{Variable_WorkDb}].dbo.KL_KBK KBK ON KBK.LINK = KK.LINK
	) kk ON kk.Ref =  case
						when ar.{DB_KR}<>'''' then ar.{DB_KR}
						else ''00000000-0000-0000-0000-000000000000''
					end
		AND (CNT = 1 OR CNT > 1 AND kk.[TYPE] = [{Variable_WorkDb}].dbo.SA_DEF_TYPE_KBK(sa.cSinth, sa.cAnalit, sa.KBK_TYPE, sa.P_KASSA, k2.LINK, k.LINK))

LEFT JOIN 
	(
	SELECT LINK, REF FROM [{Variable_TempDb}].dbo.__KAU_ bal
	UNION
	SELECT LINK, REF FROM [{Variable_TempDb}].dbo.__KAU_ bal1 
	UNION
	SELECT LINK, REF FROM [{Variable_TempDb}].dbo.__KAU_ bal2
	UNION
	SELECT LINK, REF FROM [{Variable_TempDb}].dbo.[__KAU_] bal3
	UNION
	SELECT LINK, REF FROM [{Variable_TempDb}].dbo.[__KAU_] bal4
	UNION
	SELECT LINK, REF FROM [{Variable_TempDb}].dbo.[__KAU_] bal5
	) AS KAU ON KAU.Ref = COALESCE(ar., ar.KAU_{DB_KR}) 
'
INSERT INTO #tSQL_FROM ([text]) SELECT
'  
 LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV_ gp2 ON gp2.Ref = ar.AP1_{DB_KR}

 LEFT JOIN [{Variable_TempDb}].dbo.__DOP_CLASSIF_ dcl ON dcl.Ref = ar.AP2_{DB_KR}
'

--  .  __PROV_ANALIT_1C
DECLARE
	@DB_KR	TINYINT,
	@cFROM_DEP_ACC	VARCHAR (8000),
	@DBKR_1C	VARCHAR (2)

SET @DB_KR = 0

WHILE @DB_KR < 2
BEGIN
	IF @DB_KR = 0
		SET @DBKR_1C = 'Dr'

	IF @DB_KR = 1
		SET @DBKR_1C = 'Cr'

	INSERT INTO #EXEC ([text]) SELECT
'    
INSERT INTO [{Variable_TempDb}].[dbo].[__PROV_ANALIT_1C] 
    (
	LINK_UP,
	RECORDER, DB_KR,
	ACCOUNT, ACC_CODE,
	[KBK], [EKR], [DEP], [SUB], [EMP],
	[NOMEN],[INV],[KAU],[DEP_ACC],[TMC],
	[SGU],
	[AP1],[AP2] --,[D_AP3],[D_AP4],[D_AP5],[D_AP6]
	)
'
	INSERT INTO #EXEC ([text]) SELECT
'    
SELECT
	LINK_UP =	AR.LINK,
	AR.RECORDER,
	'	+ CONVERT (VARCHAR (1), @DB_KR) + ',

    ACCOUNT	= sa.LINK,
	ACC_CODE = fo.CODE + ''.'' + acc.CODE,

    KBK        = kk.LINK, 
    EKR        = k2.LINK,
    DEP        = d.LINK, 
    SUB        = SP.LINK_UP, 
    EMP        = ISNULL(es.LINK,
           (SELECT TOP 1 e.LINK 
            FROM [{Variable_TempDb}].dbo.__EMPL_ e
            INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co2 ON co2. = ar.DEP_' + @DBKR_1C + ' AND e.Ref = co2.Ref)), 
    NOMEN      = ISNULL (n.LINK, DD.LINK),
    INV        = ISNULL (INV2.LINK, INV1.LINK),
    KAU        = KAU.LINK,
	'

	IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]')
	and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND (
		@DB_KR = 0 AND COLUMNPROPERTY(object_id('[{Variable_TempDb}].[dbo].[AccountingRegisterRecordSet|]'), 'DEP_ACC_DR', 'AllowsNull') is NOT NULL
		OR
		@DB_KR = 1 AND COLUMNPROPERTY(object_id('[{Variable_TempDb}].[dbo].[AccountingRegisterRecordSet|]'), 'DEP_ACC_CR', 'AllowsNull') is NOT NULL
		)
	BEGIN
		INSERT INTO #EXEC ([text]) SELECT '
			DEP_ACC    = a.LINK,'

		SET @cFROM_DEP_ACC = 
' 
LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] rls ON rls.Ref = '
	+	'ar.DEP_ACC_' + @DBKR_1C
+
'
LEFT JOIN [{Variable_TempDb}].dbo.__ACCOUNTS_ a ON a.Ref = rls.[Owner]
'

	END
	ELSE
	BEGIN
		INSERT INTO #EXEC ([text]) SELECT '
				DEP_ACC    = NULL,'

		SET @cFROM_DEP_ACC = ''
	END

	INSERT INTO #EXEC ([text]) SELECT '        
    TMC        = ISNULL(n.LINK,bso.LINK),
	SGU        = k.LINK, 
    AP1        = gp2.LINK,
	AP2        = dcl.LINK
'

	INSERT INTO #EXEC ([text])
	SELECT 
		REPLACE ([text], '{DB_KR}', @DBKR_1C)
	FROM #tSQL_FROM
	ORDER BY ORD1

	INSERT INTO #EXEC ([text])
	SELECT 
		@cFROM_DEP_ACC

	INSERT INTO #EXEC ([text])
	SELECT 
'
WHERE ar.[Active] = 1
'
	SET @DB_KR = @DB_KR + 1
END
select text from #EXEC order by id
DECLARE @err INT
EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'

COMMIT TRAN

GO

