
set xact_abort on
BEGIN TRAN
--  
--   
USE [{Variable_TempDb}]
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__GROUP_ACTIVE__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__GROUP_ACTIVE__] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER,
  VARCHAR(5))
ELSE 
	DELETE FROM [dbo].[__GROUP_ACTIVE__]

-----      Level,     
USE [{Variable_TempDb}]
GO
  
----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].GROUP_ACTIVE'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].GROUP_ACTIVE DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].GROUP_ACTIVE ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

DECLARE @iOBJECT_OS INT, @iOBJECT_MZ INT, @iLINK_UNKNOWN_GROUP INT
/*
SELECT @iOBJECT_OS = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so
WHERE so.CODE = 'INVENTORY_CARD'

SELECT @iOBJECT_MZ = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so
WHERE so.CODE = 'NOMENCLATURE_MAT_CEN'

SELECT TOP 1 @iLINK_UNKNOWN_GROUP = ga.LINK FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga WHERE ga.CODE_GRP = '00000'

/***************************  ,     ******************************/

INSERT INTO [{Variable_TempDb}].dbo.[__GROUP_ACTIVE__] (LINK,[Ref])
SELECT DISTINCT
	GA2.LINK,
    p.Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] p
	INNER JOIN (
		SELECT Parent, , NUM = ROW_NUMBER() OVER (PARTITION BY Parent ORDER BY  DESC)  
			FROM [{Variable_TempDb}].dbo.[CatalogObject|] 
	) C ON convert(uniqueidentifier,c.Parent) = p.Ref AND c.NUM = 1	
	LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = CASE WHEN c. = '' THEN NULL ELSE c. END AND sa.LINK_DEP = {LINK_DEP}
	LEFT JOIN [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga ON ga.CODE_GRP = REPLACE(c.,'.','') AND ga.LINK_DEP = [{Variable_WorkDb}].dbo.getOwnDepLink()
	INNER JOIN 
		(SELECT LINK, [CODE_GRP], [NAME], [OBJECT], [LINK_SELF], NUM = ROW_NUMBER() OVER (PARTITION BY [CODE_GRP], [NAME], [OBJECT], [LINK_SELF] ORDER BY LINK) 
			FROM
				[{Variable_WorkDb}].dbo.GROUP_ACTIVE
			WHERE
				[LINK_DEP] = {LINK_DEP}
		) GA2 ON GA2.NUM = 1
			AND	
			GA2.[CODE_GRP] = CASE WHEN ISNULL(REPLACE(c.,'.',''),'') = '' THEN '00000' ELSE RIGHT(ISNULL(REPLACE(c.,'.',''),''),5) END
			AND
			GA2.[NAME] = CASE WHEN ISNULL(p.,'') = '' THEN p.[Description] ELSE p. END
			AND
			GA2.[OBJECT] = CASE WHEN LEFT(REPLACE(c.,'.',''),3) = '105' THEN @iOBJECT_MZ ELSE @iOBJECT_OS END
			AND
			GA2.[LINK_SELF] = ISNULL(ga.LINK,@iLINK_UNKNOWN_GROUP)

-----------
INSERT INTO [{Variable_WorkDb}].dbo.GROUP_ACTIVE
	(CODE_GRP, [NAME], ACCOUNT_B, [SYSTEM], [TYPE], ACCOUNT_AM, ISUSED, LINK_SELF,
	CODE_PRF, [OBJECT],LINK_DEP,[INSERTED_UIDS])
OUTPUT INSERTED.link,INSERTED.[INSERTED_UIDS],INSERTED.CODE_GRP
	INTO [{Variable_TempDb}].dbo.[__GROUP_ACTIVE__]
SELECT DISTINCT
    CODE_GRP    = CASE WHEN ISNULL(REPLACE(c.,'.',''),'') = '' THEN '00000' ELSE RIGHT(ISNULL(REPLACE(c.,'.',''),''),5) END,
    [NAME]      = CASE WHEN ISNULL(p.,'') = '' THEN p.[Description] ELSE p. END,
    ACCOUNT_B   = sa.LINK, 
    [SYSTEM]    = 0, 
    [TYPE]      = 2, 
    ACCOUNT_AM  = NULL,
    ISUSED      = 1,
    LINK_SELF   = ISNULL(ga.LINK,@iLINK_UNKNOWN_GROUP),
    CODE_PRF    = NULL ,
    [OBJECT]    = CASE WHEN LEFT(REPLACE(c.,'.',''),3) = '105' THEN @iOBJECT_MZ ELSE @iOBJECT_OS END ,
    LINK_DEP    = {LINK_DEP},
    [INSERTED_UIDS] = p.Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] p
	INNER JOIN (
		SELECT Parent, , NUM = ROW_NUMBER() OVER (PARTITION BY Parent ORDER BY  DESC)  
			FROM [{Variable_TempDb}].dbo.[CatalogObject|] 
	) C ON convert(uniqueidentifier,c.Parent) = p.Ref AND c.NUM = 1	
	LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = CASE WHEN c. = '' THEN NULL ELSE c. END AND sa.LINK_DEP = {LINK_DEP}
	LEFT JOIN [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga ON ga.CODE_GRP = REPLACE(c.,'.','') AND ga.LINK_DEP = [{Variable_WorkDb}].dbo.getOwnDepLink()
WHERE
	NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__GROUP_ACTIVE__] T WHERE T.[Ref] = p.Ref )	

/*************************************************************************/
--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT 
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
*/
--
ALTER TABLE [{Variable_WorkDb}].[dbo].GROUP_ACTIVE DROP COLUMN [INSERTED_UIDS]
GO

COMMIT TRAN

