SET XACT_ABORT ON
BEGIN TRAN

IF not exists(select * from sysobjects where id = object_id('[dbo].[__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__] (
	code varchar(1),
	name varchar(250) )
ELSE 
	DELETE FROM [dbo].[__]

GO

insert into __
select '1',''
union all
select '2',''
union all
select '4',''
union all
select '3',''
union all
select '5',''
union all
select '6',''
union all
select '7',''

go

---        
--- AP1
-- DT
UPDATE sa
SET sa.ap_AP1 = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.

WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountDr = ar.AccountDr AND ISNULL(ar1.AP1_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_AP1 = 0
-- KT
UPDATE sa
SET sa.ap_AP1 = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountCr = ar.AccountCr AND ISNULL(ar1.AP1_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_AP1 = 0

--- KBK
-- DT
UPDATE sa
SET sa.ap_KBK = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountDr = ar.AccountDr AND ISNULL(ar1.Dr,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP ={LINK_DEP}
WHERE sa.ap_KBK = 0
-- KT
UPDATE sa
SET sa.ap_KBK = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountCr = ar.AccountCr AND ISNULL(ar1.Cr,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_KBK = 0

--- DEP
-- DT
UPDATE sa
SET sa.ap_DEP = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountDr = ar.AccountDr AND ISNULL(ar1.DEP_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_DEP = 0
-- KT
UPDATE sa
SET sa.ap_DEP = 1
FROM (
SELECT ACC_CODE = (k.code+ '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountCr = ar.AccountCr AND ISNULL(ar1.DEP_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_DEP = 0

--- EMP
-- DT
UPDATE sa
SET sa.ap_EMP = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountDr = ar.AccountDr AND ISNULL(ar1.EMP_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_EMP = 0
-- KT
UPDATE sa
SET sa.ap_EMP = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountCr = ar.AccountCr AND ISNULL(ar1.EMP_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_EMP = 0

--- NOMEN
-- DT
--NOMEN
UPDATE sa
SET 
sa.NOMEN_TYPE = 3,
sa.ap_NOMEN = 1
FROM (
SELECT ACC_CODE = (k.code+ '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountDr = ar.AccountDr AND (ISNULL(ar1.NOMEN_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'))
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_NOMEN = 0
--ND
UPDATE sa
SET 
sa.NOMEN_TYPE = 3,
sa.ap_NOMEN = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountDr = ar.AccountDr AND (ISNULL(ar1.ND_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'))
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_NOMEN = 0
--BSO
UPDATE sa
SET 
sa.NOMEN_TYPE = 3,
sa.ap_NOMEN = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountDr = ar.AccountDr AND (ISNULL(ar1.BSO_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'))
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_NOMEN = 0
-- KT
-- NOMEN
UPDATE sa
SET 
sa.NOMEN_TYPE = 3,
sa.ap_NOMEN = 1
FROM (
SELECT ACC_CODE = (k.code+ '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountCr = ar.AccountCr AND (ISNULL(ar1.NOMEN_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'))
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_NOMEN = 0
-- ND
UPDATE sa
SET 
sa.NOMEN_TYPE = 3,
sa.ap_NOMEN = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountCr = ar.AccountCr AND (ISNULL(ar1.ND_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'))
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_NOMEN = 0
-- BSO
UPDATE sa
SET 
sa.NOMEN_TYPE = 3,
sa.ap_NOMEN = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountCr = ar.AccountCr AND (ISNULL(ar1.BSO_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'))
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_NOMEN = 0

--- INV
--         ,       ,    
-- DT
UPDATE sa
SET sa.ap_TMC = 0
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountDr = ar.AccountDr AND ISNULL(ar1.INV_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_INV = 0 AND sa.ap_TMC = 1
-- KT
UPDATE sa
SET sa.ap_TMC = 0
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountCr = ar.AccountCr AND ISNULL(ar1.INV_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_INV = 0 AND sa.ap_TMC = 1
--  
-- DT
UPDATE sa
SET sa.ap_INV = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountDr = ar.AccountDr AND ISNULL(ar1.INV_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_INV = 0
-- KT
UPDATE sa
SET sa.ap_INV = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
WHERE EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 WHERE ar1.AccountCr = ar.AccountCr AND ISNULL(ar1.INV_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000')
GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_INV = 0

--- EKR
-- DT
UPDATE sa
SET sa.ap_EKR = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
	WHERE 
		EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 
				WHERE ar1.AccountDr = ar.AccountDr 
						AND (CASE WHEN ch.OffBalance = 'true' 
								THEN ISNULL(ar1.EKR_DR, ISNULL(ar1.SGU_DR,'00000000-0000-0000-0000-000000000000')) 
								ELSE ISNULL(ar1.EKR_DR,'00000000-0000-0000-0000-000000000000') 
							END) <> '00000000-0000-0000-0000-000000000000')
	GROUP BY 
		k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_EKR = 0
-- KT
UPDATE sa
SET sa.ap_EKR = 1
FROM (
SELECT ACC_CODE = (k.code + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
 left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
	WHERE 
		EXISTS (SELECT 1 FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar1 
				WHERE ar1.AccountCr = ar.AccountCr 
						AND (CASE WHEN ch.OffBalance = 'true' 
								THEN ISNULL(ar1.EKR_CR, ISNULL(ar1.SGU_CR,'00000000-0000-0000-0000-000000000000')) 
								ELSE ISNULL(ar1.EKR_CR,'00000000-0000-0000-0000-000000000000') 
							END) <> '00000000-0000-0000-0000-000000000000')
	GROUP BY 
		k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
WHERE sa.ap_EKR = 0

--- AP2
-- DT
UPDATE sa
SET sa.ap_AP2 = 1
FROM
	(
	SELECT ACC_CODE = (k.code + '.' + ch.CODE)
	FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
	INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
	left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
	WHERE
		ISNULL(ar.AP2_Dr, '00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
		OR ISNULL(ar.ND_Dr, '00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
	GROUP BY k.code,ch.Code) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
	sa.ap_AP2 = 0
	AND sa.CODE = ss.ACC_CODE
	AND sa.LINK_DEP = {LINK_DEP}

-- KT
UPDATE sa
SET sa.ap_AP2 = 1
FROM
	(
	SELECT ACC_CODE = (k.code + '.' + ch.CODE)
	FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
	INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
	left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
	WHERE
		ISNULL(ar.AP2_Cr, '00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
		OR ISNULL(ar.ND_Cr, '00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
	GROUP BY k.code,ch.Code
	) AS ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
	sa.ap_AP2 = 0
	AND sa.CODE = ss.ACC_CODE
	AND sa.LINK_DEP = {LINK_DEP}
        
COMMIT TRAN

