IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_ACCOUNTS_TO_ADD]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_ACCOUNTS_TO_ADD]
GO

SELECT DISTINCT  = s.CODE,  = s.[Description],  = s.ss 
INTO #TEMP
FROM (
    SELECT (k.code + '.' + acc.Code) AS CODE, acc.[Description], CASE WHEN ar.Period > '20140101' THEN '' ELSE '' END AS ss
    FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
    LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] acc ON acc.Ref = ar.AccountDr
    left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
    LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_1C sa ON sa.CODE = k.code+ '.' + acc.Code AND sa.LINK_DEP = {LINK_DEP}
    WHERE sa.LINK IS NULL
    UNION ALL
    SELECT (k.code + '.' + acc.Code) AS CODE, acc.[Description], CASE WHEN ar.Period > '20140101' THEN '' ELSE '' END AS ss
    FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
    LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] acc ON acc.Ref = ar.AccountCr
      left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
    LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_1C sa ON sa.CODE = k.code + '.' + acc.Code AND sa.LINK_DEP = {LINK_DEP}
    WHERE sa.LINK IS NULL) AS s
WHERE s.CODE IS NOT NULL

SELECT , ,  = '  '
INTO #TEMP2
FROM #TEMP 
GROUP BY ,  HAVING COUNT(*) > 1

SELECT * 
INTO [{Variable_TempDb}].dbo.[__JOURNAL_ACCOUNTS_TO_ADD]
FROM (
    SELECT * FROM #TEMP2
    UNION ALL
    SELECT * FROM #TEMP WHERE  NOT IN (SELECT  FROM #TEMP2)
    )AS s
ORDER BY s., s.

DECLARE @iROWS_COUNT BIGINT
SET @iROWS_COUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ', '  ', '__JOURNAL_ACCOUNTS_TO_ADD',ISNULL(@iROWS_COUNT,0))

DROP TABLE #TEMP
DROP TABLE #TEMP2
