
UPDATE GAP SET GAP.DEP_ACC = DA.LINK
FROM
	{Variable_WorkDb}.dbo.G_PROV G
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAP ON GAP.LINK_UP = G2.LINK
	INNER JOIN {Variable_TempDb}.dbo.__DEPARTMENTS_ TC ON TC.LINK = GAP.DEP
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENT_ACCOUNTS DA ON DA.LINK_UP = TC.LINK AND G.DEP = DA.DEP
	INNER JOIN {Variable_TempDb}.dbo.__DEPARTMENTS__ TD ON TD.LINK = DA.LINK
WHERE
	GAP.DEP IS NOT NULL
	AND
	GAP.DEP_ACC IS NULL	
GO

UPDATE S SET S.DEP_ACC = DA.LINK
FROM
	{Variable_WorkDb}.dbo.SALDO S
	INNER JOIN {Variable_TempDb}.dbo.__DEPARTMENTS_ TC ON TC.LINK = S.DEP
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENT_ACCOUNTS DA ON DA.LINK_UP = TC.LINK AND S.DEP_LINK = DA.DEP
	INNER JOIN {Variable_TempDb}.dbo.__DEPARTMENTS__ TD ON TD.LINK = DA.LINK
WHERE
	S.ISOBOROT = 2
	AND
	S.DEP IS NOT NULL
	AND
	S.DEP_ACC IS NULL		
GO

